import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Random;

public class BasicNode implements Node {
	private List<Node> children = new ArrayList<>();
	private long value;
	private int depth = 0;
	private static Random r = new Random();
	
	public static BasicNode createTree(int depth) {
		if (depth == 0) {
			return new BasicNode(r.nextInt(1000));
		}
		BasicNode left = createTree(depth - 1);
		BasicNode right = createTree(depth - 1);
		BasicNode res = new BasicNode(r.nextInt(1000));
		res.add(left);
		res.add(right);
		return res;
	}
	
	public BasicNode(long value) {
		this.value = value;
	}
	
	public void add(Node ch) {
		depth = Math.max(ch.depth()+1, depth);
		children.add(ch);		
	}

	@Override
	public List<Node> getChildren() {		
		return children;
	}

	@Override
	public long getValue() {		
		return value;
	}

	@Override
	public int depth() {
		return depth;
	}
	
}
