import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ForkJoinPool;
import java.util.concurrent.ForkJoinTask;
import java.util.stream.Collectors;

public class ForkJoinPoolStreams {
	public static void main(String[] args) throws InterruptedException, ExecutionException {
		List<Integer> numbers = new ArrayList<>();
		for (int i = 0; i < 10_000_000; i++) {
			numbers.add((int) Math.round(Math.random() * 100));
		}

		ForkJoinPool forkJoinPool = new ForkJoinPool(4);
		long start = System.currentTimeMillis();
		ForkJoinTask<List<Integer>> task =
				forkJoinPool.submit(() -> {
					return numbers.parallelStream()
							.filter(n -> n % 2 == 0)
							.sorted()
							.collect(Collectors.toList());
		});
		List<Integer> even = task.get();
		System.out.printf("%d elements computed in %5d msecs with %d threads\n", 
				even.size(), System.currentTimeMillis() - start,
				Thread.activeCount());
	}
}