import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

public class SeqStream {

	public static void main(String[] args) {
		List<Integer> numbers = new ArrayList<>();
		for (int i = 0; i < 10_000_000; i++) {
			numbers.add((int) Math.round(Math.random() * 100));
		}
		
		for (int i = 0; i < 100; i++) {
			long start = System.currentTimeMillis();
			List<Integer> even = numbers.stream()
					.filter(n -> n % 2 == 0)
					.sorted()
					.collect(Collectors.toList());
			System.out.printf("%d elements computed in %5d msecs with %d threads\n", 
					even.size(), System.currentTimeMillis() - start,
					Thread.activeCount());
		}		
	}

}
