import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.concurrent.ConcurrentSkipListSet;
import java.util.stream.Collectors;

public class SeqStream2 {

	public static void main(String[] args) {
		List<Integer> numbers = new ArrayList<>();
		for (int i = 0; i < 10_000_000; i++) {
			numbers.add((int) Math.round(Math.random() * 100));
		}
		
		Set<String> workerThreadNames = new ConcurrentSkipListSet<>();
		for (int i = 0; i < 10; i++) {
			long start = System.currentTimeMillis();
			List<Integer> even = numbers.stream()
					.filter(n -> n % 2 == 0)
					.peek(n -> workerThreadNames.add(
							Thread.currentThread().getName()))
					.sorted()
					.collect(Collectors.toList());
			System.out.printf("%d elements computed in %5d msecs with %d threads\n", 
					even.size(), System.currentTimeMillis() - start,
					workerThreadNames.size());
			
			System.out.println(workerThreadNames.toString());
		}		
	}

}
